"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "PopupScene", {
    enumerable: true,
    get: ()=>PopupScene
});
const _sigl = /*#__PURE__*/ _interopRequireWildcard(require("sigl"));
function _getRequireWildcardCache(nodeInterop) {
    if (typeof WeakMap !== "function") return null;
    var cacheBabelInterop = new WeakMap();
    var cacheNodeInterop = new WeakMap();
    return (_getRequireWildcardCache = function(nodeInterop) {
        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
    })(nodeInterop);
}
function _interopRequireWildcard(obj, nodeInterop) {
    if (!nodeInterop && obj && obj.__esModule) {
        return obj;
    }
    if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
        return {
            default: obj
        };
    }
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj)) {
        return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for(var key in obj){
        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc);
            } else {
                newObj[key] = obj[key];
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj);
    }
    return newObj;
}
const getViewportRect = ()=>new _sigl.Rect(document.scrollingElement.scrollLeft, document.scrollingElement.scrollTop, window.visualViewport.width, window.visualViewport.height);
let PopupScene = class PopupScene {
    viewportRect;
    viewMatrix;
    runCollisions;
    // @ts-ignore
    $;
    context;
    popups;
    constructor(surface){
        this.surface = surface;
        this.viewportRect = getViewportRect();
        this.viewMatrix = new _sigl.Matrix();
        this.popups = new Set();
        _sigl.default.ContextClass.attach(this, _sigl.default);
        this.create();
    }
    destroy() {
        this.context.cleanup();
    }
    create() {
        const { $  } = this;
        // read surface
        $.effect(({ surface  })=>surface.$.effect(({ viewMatrix  })=>{
                $.viewMatrix = new _sigl.Matrix([
                    ...viewMatrix.toFloat64Array()
                ]);
            }));
        $.effect(({ surface  })=>$.observe.resize(surface, ()=>{
                $.viewportRect = _sigl.Rect.fromElement(surface) //.getBoundingClientRect()) //getViewportRect()
                ;
            }));
        $.runCollisions = $.reduce(({ popups  })=>()=>{
                for (const popup of popups){
                    popup.rect = popup.place(popup.placement ?? popup.originalPlacement).containSelf($.viewportRect);
                }
                for(let i = 0; i < 10; i++){
                    for (const a of popups){
                        for (const b of popups){
                            if (a === b) continue;
                            if (a.rect.intersectsRect(b.rect)) {
                                const c = a.rect.collisionResponse(b.rect);
                                a.rect.translateSelf(c.scale(0.5)).containSelf($.viewportRect);
                                b.rect.translateSelf(c.scale(-0.5)).containSelf($.viewportRect);
                            }
                        }
                        a.rect = a.rect.clone();
                    }
                }
            });
        $.effect(({ surface , runCollisions  })=>surface.$.effect(({ viewStyleTransform: _  })=>{
                runCollisions();
            }));
    }
    surface;
};

//# sourceMappingURL=popup-scene.js.map