"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "Popup", {
    enumerable: true,
    get: ()=>Popup
});
const _sigl = /*#__PURE__*/ _interopRequireWildcard(require("sigl"));
const _everydayUtils = require("everyday-utils");
const _xSurface = require("x-surface");
function _getRequireWildcardCache(nodeInterop) {
    if (typeof WeakMap !== "function") return null;
    var cacheBabelInterop = new WeakMap();
    var cacheNodeInterop = new WeakMap();
    return (_getRequireWildcardCache = function(nodeInterop) {
        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
    })(nodeInterop);
}
function _interopRequireWildcard(obj, nodeInterop) {
    if (!nodeInterop && obj && obj.__esModule) {
        return obj;
    }
    if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
        return {
            default: obj
        };
    }
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj)) {
        return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for(var key in obj){
        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc);
            } else {
                newObj[key] = obj[key];
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj);
    }
    return newObj;
}
let Popup = class Popup {
    static create(data) {
        const popup = new Popup(data);
        popup.attach();
        popup.create();
        return popup;
    }
    id = (0, _everydayUtils.cheapRandomId)();
    scene;
    mode = 'local';
    vel = new _sigl.Point();
    rect;
    rectDest = new _sigl.Rect();
    prevPos = new _sigl.Point();
    placement;
    originalPlacement;
    center;
    contentsRect;
    destRect;
    $;
    context;
    viewMatrix;
    // physics
    place;
    collisions = new Map();
    viewportIntersection = _sigl.Intersect.None;
    exceedsViewport = false;
    destExceedsViewport = false;
    destWithinViewport = false;
    surface;
    constructor(data = {}){
        Object.assign(this, data);
    }
    attach() {
        _sigl.default.ContextClass.attach(this);
    }
    create() {
        const { $  } = this;
        $.place = $.reduce(({ contentsRect , destRect  })=>(placement)=>contentsRect.place(destRect, placement));
        $.surface = $.fulfill(({ scene  })=>(fulfill)=>scene.$.effect(({ surface  })=>fulfill(surface)));
        $.effect.raf(({ surface , scene , destRect: _  })=>{
            if (surface.state.is(_xSurface.SurfaceState.Overlay)) {
                scene?.runCollisions?.();
            }
        });
    }
};

//# sourceMappingURL=popup.js.map