import $ from 'sigl';
import { cheapRandomId } from 'everyday-utils';
import { Intersect, Point, Rect } from 'sigl';
import { SurfaceState } from 'x-surface';
export class Popup {
    static create(data) {
        const popup = new Popup(data);
        popup.attach();
        popup.create();
        return popup;
    }
    id = cheapRandomId();
    scene;
    mode = 'local';
    vel = new Point();
    rect;
    rectDest = new Rect();
    prevPos = new Point();
    placement;
    originalPlacement;
    center;
    contentsRect;
    destRect;
    $;
    context;
    viewMatrix;
    // physics
    place;
    collisions = new Map();
    viewportIntersection = Intersect.None;
    exceedsViewport = false;
    destExceedsViewport = false;
    destWithinViewport = false;
    surface;
    constructor(data = {}){
        Object.assign(this, data);
    }
    attach() {
        $.ContextClass.attach(this);
    }
    create() {
        const { $  } = this;
        $.place = $.reduce(({ contentsRect , destRect  })=>(placement)=>contentsRect.place(destRect, placement));
        $.surface = $.fulfill(({ scene  })=>(fulfill)=>scene.$.effect(({ surface  })=>fulfill(surface)));
        $.effect.raf(({ surface , scene , destRect: _  })=>{
            if (surface.state.is(SurfaceState.Overlay)) {
                scene?.runCollisions?.();
            }
        });
    }
}

//# sourceMappingURL=popup.js.map