import $ from 'sigl';
import { Intersect, Matrix, Placement, Point, Rect } from 'sigl';
import { SurfaceElement } from 'x-surface';
import { PopupScene } from './popup-scene';
export declare class Popup {
    static create(data: Partial<Popup>): Popup;
    id: string;
    scene?: PopupScene;
    mode?: 'worker' | 'local';
    vel: Point;
    rect: Rect;
    rectDest: Rect;
    prevPos: Point;
    placement: Placement;
    originalPlacement: Placement;
    center: boolean;
    contentsRect: Rect;
    destRect: Rect;
    $: $.Context<Popup>;
    context: $.ContextClass<Popup>;
    viewMatrix?: Matrix;
    place?: (placement: Placement) => Rect;
    collisions: Map<Popup, Point>;
    viewportIntersection: Intersect;
    exceedsViewport: boolean;
    destExceedsViewport: boolean;
    destWithinViewport: boolean;
    surface?: SurfaceElement;
    constructor(data?: Partial<Popup>);
    attach(this: Popup): void;
    create(this: Popup): void;
}
