/** @jsxImportSource sigl */
import $, { Point } from 'sigl';
import type { ValuesOf } from 'sigl';
import { Matrix, Rect } from 'sigl';
import { SurfaceElement, SurfaceItemElement, SurfaceState } from 'x-surface';
import type { Placement } from 'sigl';
import { Popup } from './popup';
import type { PopupScene } from './popup-scene';
export interface PopupElement extends $.Element<PopupElement> {
}
export declare class PopupElement extends HTMLElement {
    placement: Placement;
    placed: boolean;
    center: boolean;
    rigid: boolean;
    transition: ValuesOf<typeof SurfaceState>;
    surface?: SurfaceElement;
    scene?: PopupScene;
    contents?: HTMLDivElement;
    contentsRect?: Rect;
    dest?: SurfaceItemElement;
    destRect?: Rect;
    popup?: Popup;
    rect?: Rect;
    pos?: Point;
    viewMatrix?: Matrix;
    viewportRect?: Rect;
    hostMatrixString?: string;
    setHostStyleTransform?: (matrixString: string) => void;
    mounted($: PopupElement['$']): void;
}
